Index: lib/libc/shlib_version
===================================================================
RCS file: /cvs/OpenBSD/src/lib/libc/shlib_version,v
retrieving revision 1.112
retrieving revision 1.112.4.2
diff -u -r1.112 -r1.112.4.2
--- lib/libc/shlib_version	24 Jul 2008 09:31:06 -0000	1.112
+++ lib/libc/shlib_version	13 Feb 2009 09:08:58 -0000	1.112.4.2
@@ -1,4 +1,4 @@
 major=48
-minor=0
+minor=3
 # note: If changes were made to include/thread_private.h or if system
 # calls were added/changed then libpthread must also be updated.
Index: lib/libc/gen/errlist.c
===================================================================
RCS file: /cvs/OpenBSD/src/lib/libc/gen/errlist.c,v
retrieving revision 1.12
retrieving revision 1.12.6.2
diff -u -r1.12 -r1.12.6.2
--- lib/libc/gen/errlist.c	3 Sep 2007 14:37:52 -0000	1.12
+++ lib/libc/gen/errlist.c	13 Feb 2009 09:08:58 -0000	1.12.6.2
@@ -144,5 +144,7 @@
 	"Operation canceled",			/* 88 - ECANCELED */
 	"Identifier removed",			/* 89 - EIDRM */
 	"No message of desired type",		/* 90 - ENOMSG */
+	"No such instance",			/* 91 - EINSTSRCH */
+	"Instance exists",			/* 92 - EINSTEXIT */
 };
 int _sys_nerr = { sizeof _sys_errlist/sizeof _sys_errlist[0] };
Index: lib/libc/sys/Makefile.inc
===================================================================
RCS file: /cvs/OpenBSD/src/lib/libc/sys/Makefile.inc,v
retrieving revision 1.85
retrieving revision 1.85.4.2
diff -u -r1.85 -r1.85.4.2
--- lib/libc/sys/Makefile.inc	22 Mar 2008 19:18:42 -0000	1.85
+++ lib/libc/sys/Makefile.inc	13 Feb 2009 09:08:58 -0000	1.85.4.2
@@ -38,15 +38,16 @@
 	chown.o chroot.o clock_gettime.o clock_settime.o clock_getres.o \
 	close.o closefrom.o connect.o dup.o dup2.o execve.o fchdir.o \
 	fchflags.o fchmod.o fchown.o fcntl.o fhopen.o fhstat.o fhstatfs.o \
-	flock.o fpathconf.o fstat.o \
+	flock.o forkinst.o fpathconf.o fstat.o \
 	fstatfs.o fsync.o futimes.o getdirentries.o getegid.o geteuid.o \
-	getfh.o getfsstat.o getgid.o getgroups.o getitimer.o getpeereid.o \
+	getfh.o getfsstat.o getgid.o getgroups.o getinstid.o \
+	getitimer.o getpeereid.o \
 	getpeername.o \
 	getpgid.o \
 	getpgrp.o getpid.o getppid.o getpriority.o getresgid.o getresuid.o \
 	getrlimit.o getrusage.o getsid.o \
 	getsockname.o getsockopt.o gettimeofday.o getuid.o issetugid.o \
-	ioctl.o kill.o kevent.o kqueue.o \
+	ioctl.o kill.o killinst.o kevent.o kqueue.o \
 	ktrace.o lchown.o lfs_bmapv.o lfs_markv.o lfs_segclean.o lfs_segwait.o \
 	link.o listen.o lstat.o madvise.o mincore.o minherit.o mkdir.o \
 	mkfifo.o mknod.o mlock.o mlockall.o \
@@ -213,12 +214,12 @@
 	chflags.2 \
 	chmod.2 chown.2 chroot.2 clock_gettime.2 close.2 closefrom.2 connect.2 \
 	dup.2 execve.2 _exit.2 fcntl.2 fhopen.2 \
-	flock.2 fork.2 fsync.2 getdirentries.2 \
+	flock.2 fork.2 forkinst.2 fsync.2 getdirentries.2 \
 	getfh.2 getfsstat.2 getgid.2 getgroups.2 getitimer.2 getlogin.2 \
 	getpeername.2 getpeereid.2 getpgrp.2 \
 	getpid.2 getpriority.2 getrlimit.2 getrusage.2 getsid.2 getsockname.2 \
 	getsockopt.2 gettimeofday.2 getuid.2 intro.2 issetugid.2 ioctl.2 \
-	kill.2 kqueue.2 ktrace.2 link.2 \
+	kill.2 killinst.2 kqueue.2 ktrace.2 link.2 \
 	listen.2 lseek.2 mkdir.2 mkfifo.2 mknod.2 madvise.2 \
 	mquery.2 mincore.2 minherit.2 mlock.2 mlockall.2 \
 	mmap.2 mount.2 mprotect.2 msync.2 munmap.2 nanosleep.2 \
@@ -254,7 +255,8 @@
 MLINKS+=getitimer.2 timersub.3
 MLINKS+=getlogin.2 getlogin_r.2 getlogin.2 setlogin.2
 MLINKS+=getpgrp.2 getpgid.2
-MLINKS+=getpid.2 getppid.2
+MLINKS+=getpid.2 getppid.2 
+MLINKS+=getpid.2 getinstid.2
 MLINKS+=getpriority.2 setpriority.2
 MLINKS+=getrlimit.2 setrlimit.2
 MLINKS+=getsockopt.2 setsockopt.2
Index: sbin/Makefile
===================================================================
RCS file: /cvs/OpenBSD/src/sbin/Makefile,v
retrieving revision 1.88
retrieving revision 1.88.4.4
diff -u -r1.88 -r1.88.4.4
--- sbin/Makefile	9 Jun 2008 22:23:18 -0000	1.88
+++ sbin/Makefile	12 Feb 2009 14:38:06 -0000	1.88.4.4
@@ -2,7 +2,9 @@
 
 SUBDIR=	atactl badsect bioctl brconfig ccdconfig clri dhclient \
 	disklabel dmesg dump dumpfs fdisk fsck fsck_ext2fs fsck_ffs  \
-	fsck_msdos fsdb fsirand growfs ifconfig init iopctl ipsecctl  \
+	fsck_msdos fsdb fsirand growfs ifconfig init \
+	instkill instls instproc instps \
+	iopctl ipsecctl  \
 	isakmpd kbd ldattach lmccontrol mknod modload modunload mount \
 	mount_cd9660 mount_ext2fs mount_ffs mount_msdos \
 	mount_nfs mount_ntfs mount_portal mount_procfs mount_udf \
Index: sbin/instkill/Makefile
===================================================================
RCS file: sbin/instkill/Makefile
diff -N sbin/instkill/Makefile
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ sbin/instkill/Makefile	31 Jan 2009 19:14:53 -0000	1.1.2.1
@@ -0,0 +1,6 @@
+#	$OpenBSD: Makefile,v 1.2 1996/06/23 14:32:47 deraadt Exp $
+
+PROG=	instkill
+MAN=	instkill.8
+
+.include <bsd.prog.mk>
Index: sbin/instkill/instkill.c
===================================================================
RCS file: sbin/instkill/instkill.c
diff -N sbin/instkill/instkill.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ sbin/instkill/instkill.c	19 Feb 2009 10:00:30 -0000	1.1.2.5
@@ -0,0 +1,85 @@
+/*
+ * Copyright (c) 2009 Kristaps Dzonsons <kristaps@mult.bsd.lv>
+ *
+ * Permission to use, copy, modify, and distribute this software for any
+ * purpose with or without fee is hereby granted, provided that the
+ * above copyright notice and this permission notice appear in all
+ * copies.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL
+ * WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED
+ * WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE
+ * AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL
+ * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
+ * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
+ * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
+ * PERFORMANCE OF THIS SOFTWARE.
+ */
+#include <sys/inst.h>
+
+#include <err.h>
+#include <errno.h>
+#include <stdlib.h>
+
+static	int	parse_signum(const char *);
+static	void	usage(void);
+
+int
+main(int argc, char *argv[])
+{
+	int 		 signum;
+	long long	 raw;
+	instid_t	 id;
+
+	signum = 0;
+
+	argc--;
+	argv++;
+
+	signum = SIGINST_TERM;
+	if (argc >= 1 && '-' == *argv[0]) {
+		signum = parse_signum(argv[0]);
+		argc--;
+		argv++;
+	}
+
+	if (0 == argc) {
+		usage();
+		return(0);
+	}
+
+	while (argc) {
+		raw = atoll(argv[0]);
+		id = -1 == raw ? INST_NOID : (instid_t)raw;
+		if (-1 == killinst(id, signum))
+			if (EINSTSRCH != errno)
+				err(1, "killinst");
+
+		argc--;
+		argv++;
+	}
+
+	return(0);
+}
+
+
+static int
+parse_signum(const char *arg)
+{
+	if (0 == strcmp(arg, "-TERM"))
+		return(SIGINST_TERM);
+	else if (0 == strcmp(arg, "-KILL"))
+		return(SIGINST_KILL);
+	
+	errx(1, "bad signal `%s'", arg);
+	/* NOTREACHED */
+}
+
+
+static void
+usage(void)
+{
+	extern char	*__progname;
+
+	(void)printf("usage: %s [-signal_name] instid ...\n", __progname);
+}
Index: sbin/instls/Makefile
===================================================================
RCS file: sbin/instls/Makefile
diff -N sbin/instls/Makefile
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ sbin/instls/Makefile	14 Sep 2008 15:35:07 -0000	1.1.2.1
@@ -0,0 +1,6 @@
+#	$OpenBSD: Makefile,v 1.2 1996/06/23 14:32:47 deraadt Exp $
+
+PROG=	instls
+MAN=	instls.8
+
+.include <bsd.prog.mk>
Index: sbin/instls/instls.c
===================================================================
RCS file: sbin/instls/instls.c
diff -N sbin/instls/instls.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ sbin/instls/instls.c	19 Feb 2009 10:00:30 -0000	1.1.2.5
@@ -0,0 +1,143 @@
+/*
+ * Copyright (c) 2008 Kristaps Dzonsons <kristaps@mult.bsd.lv>
+ *
+ * Permission to use, copy, modify, and distribute this software for any
+ * purpose with or without fee is hereby granted, provided that the
+ * above copyright notice and this permission notice appear in all
+ * copies.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL
+ * WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED
+ * WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE
+ * AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL
+ * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
+ * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
+ * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
+ * PERFORMANCE OF THIS SOFTWARE.
+ */
+#include <sys/param.h>
+#include <sys/inst.h>
+#include <sys/sysctl.h>
+
+#include <stdio.h>
+#include <stdlib.h>
+
+
+static void
+printheader(void)
+{
+	(void)printf(" %-12s %-4s\n", "UUID", "REFS");
+}
+
+
+static void
+printline(const struct kinfo_inst *ki)
+{
+	instid_t	 id;
+
+	id = getinstid();
+
+	(void)printf("%c%-12u %-4u\n", id == ki->inst_id ?
+			'*' : ' ', ki->inst_id, ki->inst_ref);
+}
+
+
+static int
+printselect(int v)
+{
+	int		 name[6];
+	struct kinfo_inst ki;
+	size_t		 oldlen;
+
+	oldlen = sizeof(struct kinfo_inst);
+
+	name[0] = CTL_KERN;
+	name[1] = KERN_INST;
+	name[2] = KERN_INST_INSTID;
+	name[3] = v;
+	name[4] = (int)oldlen;
+	name[5] = 1;
+
+	if (-1 == sysctl(name, 6, &ki, &oldlen, NULL, 0))
+		err(1, "sysctl");
+
+	if (oldlen == 0)
+		errx(1, "instance not found: %u", (unsigned)v);
+	else if ((oldlen % sizeof(struct kinfo_inst)))
+		errx(1, "invalid kinfo_inst size");
+
+	printline(&ki);
+
+	return(1);
+}
+
+
+static int
+printall(void)
+{
+	int		 name[6];
+	struct kinfo_inst *ki;
+	size_t		 oldlen, i;
+
+	name[0] = CTL_KERN;
+	name[1] = KERN_INST;
+	name[2] = KERN_INST_ALL;
+	name[3] = 0;
+	name[4] = sizeof(struct kinfo_inst);
+	name[5] = 0;
+
+	if (-1 == sysctl(name, 6, NULL, &oldlen, NULL, 0))
+		err(1, "sysctl");
+
+	if (oldlen == 0)
+		return(1);
+	else if ((oldlen % sizeof(struct kinfo_inst)))
+		errx(1, "invalid kinfo_inst size");
+
+	if (NULL == (ki = malloc(oldlen)))
+		err(1, "malloc");
+
+	name[4] = sizeof(struct kinfo_inst);
+	name[5] = (int)(oldlen / sizeof(struct kinfo_inst));
+
+	if (-1 == sysctl(name, 6, ki, &oldlen, NULL, 0)) 
+		err(1, "sysctl");
+
+	if (oldlen == 0)
+		return(1);
+
+	else if ((oldlen % sizeof(struct kinfo_inst)))
+		errx(1, "invalid kinfo_inst size");
+
+	oldlen /= sizeof(struct kinfo_inst);
+
+	for (i = 0; i < oldlen; i++)
+		printline(&ki[(int)i]);
+
+	return(1);
+}
+
+
+int
+main(int argc, char *argv[])
+{
+	extern char	*__progname;
+
+	if (-1 != getopt(argc, argv, "")) {
+		(void)fprintf(stderr, "usage: %s [instid...]\n", 
+				__progname);
+		return(1);
+	}
+
+	printheader();
+
+	if (1 == argc)
+		return(printall() ? EXIT_SUCCESS : EXIT_FAILURE);
+
+	argv++;
+	while (*argv) 
+		if ( ! printselect(atoi(*argv++)))
+			return (EXIT_FAILURE);
+
+	return(EXIT_SUCCESS);
+}
Index: sbin/instproc/Makefile
===================================================================
RCS file: sbin/instproc/Makefile
diff -N sbin/instproc/Makefile
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ sbin/instproc/Makefile	26 Sep 2008 22:24:17 -0000	1.1.2.1
@@ -0,0 +1,6 @@
+#	$OpenBSD: Makefile,v 1.2 1996/06/23 14:32:47 deraadt Exp $
+
+PROG=	instproc
+MAN=	instproc.8
+
+.include <bsd.prog.mk>
Index: sbin/instproc/instproc.c
===================================================================
RCS file: sbin/instproc/instproc.c
diff -N sbin/instproc/instproc.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ sbin/instproc/instproc.c	19 Feb 2009 10:00:30 -0000	1.1.2.8
@@ -0,0 +1,108 @@
+/*
+ * Copyright (c) 2008 Kristaps Dzonsons <kristaps@mult.bsd.lv>
+ *
+ * Permission to use, copy, modify, and distribute this software for any
+ * purpose with or without fee is hereby granted, provided that the
+ * above copyright notice and this permission notice appear in all
+ * copies.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL
+ * WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED
+ * WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE
+ * AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL
+ * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
+ * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
+ * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
+ * PERFORMANCE OF THIS SOFTWARE.
+ */
+#include <sys/wait.h>
+#include <sys/inst.h>
+
+#include <assert.h>
+#include <errno.h>
+#include <fcntl.h>
+#include <err.h>
+#include <paths.h>
+#include <stdlib.h>
+#include <syslog.h>
+#include <unistd.h>
+
+static __dead void 	 init(char *[]);
+static void		 usage(void);
+
+int
+main(int argc, char *argv[])
+{
+	instid_t	 req;
+	int		 c, flags, inst;
+#define	ARG_PRINTID	(1 << 0)
+
+	extern int	 optind;
+	extern char	*optarg;
+
+	flags = 0;
+	req = INST_NOID;
+
+	while (-1 != (c = getopt(argc, argv, "iI:")))
+		switch (c) {
+		case ('i'):
+			flags |= ARG_PRINTID;
+			break;
+		case ('I'):
+			req = (instid_t)atoll(optarg);
+			break;
+		default:
+			usage();
+			return(1);
+		}
+
+	argv += optind;
+	if (0 == (argc -= optind)) {
+		usage();
+		return(1);
+	}
+
+	if (-1 == (inst = forkinst(req)))
+		err(1, "forkinst");
+
+	if (0 == inst)
+		init(argv);
+
+	if (flags & ARG_PRINTID)
+		(void)printf("%u\n", (instid_t)inst);
+
+	return(0);
+}
+
+
+static __dead void
+init(char *argv[])
+{
+	int		 fd;
+
+	if (-1 == (fd = open(_PATH_DEVNULL, O_RDWR, 0)))
+		_exit(1);
+
+	assert(0 == fd);
+
+	if (-1 == dup2(fd, 0))
+		_exit(1);
+	if (-1 == dup2(fd, 1))
+		_exit(1);
+	if (-1 == dup2(fd, 2))
+		_exit(1);
+
+	(void)execvp(argv[0], argv);
+	_exit(1);
+	/* NOTREACHED */
+}
+
+
+static void
+usage(void)
+{
+	extern char	*__progname;
+	(void)printf("usage: %s [-i] [-I instid] utility [args ...]\n", 
+			__progname);
+}
+
Index: sbin/instps/Makefile
===================================================================
RCS file: sbin/instps/Makefile
diff -N sbin/instps/Makefile
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ sbin/instps/Makefile	12 Feb 2009 14:38:06 -0000	1.1.2.1
@@ -0,0 +1,10 @@
+#	$OpenBSD: Makefile,v 1.7 2001/06/27 06:16:44 art Exp $
+
+PROG=	instps
+MAN=	instps.8
+SRCS=	fmt.c keyword.c nlist.c print.c ps.c
+DPADD=	${LIBM}
+LDADD=	-lm 
+
+.include <bsd.prog.mk>
+
Index: sbin/instps/extern.h
===================================================================
RCS file: sbin/instps/extern.h
diff -N sbin/instps/extern.h
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ sbin/instps/extern.h	12 Feb 2009 14:38:06 -0000	1.1.2.1
@@ -0,0 +1,84 @@
+/*	$OpenBSD: extern.h,v 1.12 2005/01/07 20:41:13 otto Exp $	*/
+/*	$NetBSD: extern.h,v 1.10 1995/05/21 13:38:27 mycroft Exp $	*/
+
+/*-
+ * Copyright (c) 1991, 1993, 1994
+ *	The Regents of the University of California.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. Neither the name of the University nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ *	@(#)extern.h	8.3 (Berkeley) 4/2/94
+ */
+
+struct nlist;
+struct var;
+struct varent;
+
+extern fixpt_t ccpu;
+extern int eval, fscale, nlistread, rawcpu, maxslp;
+extern u_int mempages;
+extern int sumrusage, termwidth, totwidth;
+extern VAR var[];
+extern VARENT *vhead;
+
+__BEGIN_DECLS
+void	 command(const struct kinfo_proc2 *, VARENT *);
+void	 cputime(const struct kinfo_proc2 *, VARENT *);
+int	 donlist(void);
+void	 emulname(const struct kinfo_proc2 *, VARENT *);
+void	 fmt_puts(const char *, int *);
+void	 fmt_putc(int, int *);
+double	 getpcpu(const struct kinfo_proc2 *);
+double	 getpmem(const struct kinfo_proc2 *);
+void	 gname(const struct kinfo_proc2 *, VARENT *);
+void	 logname(const struct kinfo_proc2 *, VARENT *);
+void	 longtname(const struct kinfo_proc2 *, VARENT *);
+void	 lstarted(const struct kinfo_proc2 *, VARENT *);
+void	 maxrss(const struct kinfo_proc2 *, VARENT *);
+void	 p_rssize(const struct kinfo_proc2 *, VARENT *);
+void	 pagein(const struct kinfo_proc2 *, VARENT *);
+void	 parsefmt(char *);
+void	 pcpu(const struct kinfo_proc2 *, VARENT *);
+void	 pmem(const struct kinfo_proc2 *, VARENT *);
+void	 pri(const struct kinfo_proc2 *, VARENT *);
+void	 printheader(void);
+void	 pvar(const struct kinfo_proc2 *kp, VARENT *);
+void	 pnice(const struct kinfo_proc2 *kp, VARENT *);
+void	 rgname(const struct kinfo_proc2 *, VARENT *);
+void	 rssize(const struct kinfo_proc2 *, VARENT *);
+void	 runame(const struct kinfo_proc2 *, VARENT *);
+void	 showkey(void);
+void	 started(const struct kinfo_proc2 *, VARENT *);
+void	 state(const struct kinfo_proc2 *, VARENT *);
+void	 tdev(const struct kinfo_proc2 *, VARENT *);
+void	 tname(const struct kinfo_proc2 *, VARENT *);
+void	 tsize(const struct kinfo_proc2 *, VARENT *);
+void	 dsize(const struct kinfo_proc2 *, VARENT *);
+void	 ssize(const struct kinfo_proc2 *, VARENT *);
+void	 ucomm(const struct kinfo_proc2 *, VARENT *);
+void	 euname(const struct kinfo_proc2 *, VARENT *);
+void	 vsize(const struct kinfo_proc2 *, VARENT *);
+void	 wchan(const struct kinfo_proc2 *, VARENT *);
+__END_DECLS
Index: sbin/instps/fmt.c
===================================================================
RCS file: sbin/instps/fmt.c
diff -N sbin/instps/fmt.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ sbin/instps/fmt.c	12 Feb 2009 14:38:06 -0000	1.1.2.1
@@ -0,0 +1,96 @@
+/*	$OpenBSD: fmt.c,v 1.8 2006/04/25 15:41:07 deraadt Exp $	*/
+
+/*-
+ * Copyright (c) 1990, 1993, 1994
+ *	The Regents of the University of California.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. Neither the name of the University nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#include <sys/param.h>
+#include <sys/user.h>
+#include <sys/time.h>
+#include <sys/resource.h>
+#include <sys/proc.h>
+#include <sys/stat.h>
+#include <sys/ioctl.h>
+#include <sys/sysctl.h>
+#include <sys/types.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <unistd.h>
+#include <vis.h>
+#include "ps.h"
+
+void
+fmt_puts(const char *s, int *leftp)
+{
+	static char *v = NULL, *nv;
+	static int maxlen = 0;
+	int len;
+
+	if (*leftp == 0)
+		return;
+	len = strlen(s) * 4 + 1;
+	if (len > maxlen) {
+		size_t newmaxlen = maxlen;
+
+		if (newmaxlen == 0)
+			newmaxlen = getpagesize();
+		while (len > newmaxlen)
+			newmaxlen *= 2;
+		nv = realloc(v, newmaxlen);
+		if (nv == 0) {
+			free(v);
+			v = NULL;
+			maxlen = 0;
+			return;
+		}
+		maxlen = newmaxlen;
+		v = nv;
+	}
+	strvis(v, s, VIS_TAB | VIS_NL | VIS_CSTYLE);
+	if (*leftp != -1) {
+		len = strlen(v);
+		if (len > *leftp) {
+			v[*leftp] = '\0';
+			*leftp = 0;
+		} else
+			*leftp -= len;
+	}
+	printf("%s", v);
+}
+
+void
+fmt_putc(int c, int *leftp)
+{
+
+	if (*leftp == 0)
+		return;
+	if (*leftp != -1)
+		*leftp -= 1;
+	putchar(c);
+}
Index: sbin/instps/keyword.c
===================================================================
RCS file: sbin/instps/keyword.c
diff -N sbin/instps/keyword.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ sbin/instps/keyword.c	12 Feb 2009 14:38:06 -0000	1.1.2.1
@@ -0,0 +1,279 @@
+/*	$OpenBSD: keyword.c,v 1.27 2007/04/13 19:20:23 miod Exp $	*/
+/*	$NetBSD: keyword.c,v 1.12.6.1 1996/05/30 21:25:13 cgd Exp $	*/
+
+/*-
+ * Copyright (c) 1990, 1993, 1994
+ *	The Regents of the University of California.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. Neither the name of the University nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#ifndef lint
+#if 0
+static char sccsid[] = "@(#)keyword.c	8.5 (Berkeley) 4/2/94";
+#else
+static char rcsid[] = "$OpenBSD: keyword.c,v 1.27 2007/04/13 19:20:23 miod Exp $";
+#endif
+#endif /* not lint */
+
+#include <sys/param.h>
+#include <sys/time.h>
+#include <sys/resource.h>
+#include <sys/proc.h>
+
+#include <err.h>
+#include <errno.h>
+#include <stddef.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+
+#include "ps.h"
+
+#include <sys/ucred.h>
+#include <sys/sysctl.h>
+
+static VAR *findvar(char *);
+static int  vcmp(const void *, const void *);
+
+#ifdef NOTINUSE
+int	utime(), stime(), ixrss(), idrss(), isrss();
+	{{"utime"}, "UTIME", USER, utime, 4},
+	{{"stime"}, "STIME", USER, stime, 4},
+	{{"ixrss"}, "IXRSS", USER, ixrss, 4},
+	{{"idrss"}, "IDRSS", USER, idrss, 4},
+	{{"isrss"}, "ISRSS", USER, isrss, 4},
+#endif
+
+/* Compute offset in common structures. */
+#define	POFF(x)	offsetof(struct kinfo_proc2, x)
+
+#define	UIDFMT	"u"
+#define	UIDLEN	5
+#define	UID(n1, n2, fn, off) \
+	{ n1, n2, NULL, 0, fn, UIDLEN, 0, off, UINT32, UIDFMT }
+#define	GID(n1, n2, fn, off)	UID(n1, n2, fn, off)
+
+#define	PIDFMT	"d"
+#define	PIDLEN	5
+#define	PID(n1, n2, fn, off) \
+	{ n1, n2, NULL, 0, fn, PIDLEN, 0, off, INT32, PIDFMT }
+
+#define	USERLEN	8
+
+/* Bit types must match their respective entries in struct kinfo_proc2 */
+VAR var[] = {
+	{"%cpu", "%CPU", NULL, NLIST, pcpu, 4},
+	{"%mem", "%MEM", NULL, NLIST, pmem, 4},
+	{"acflag", "ACFLG", NULL, 0, pvar, 3, 0, POFF(p_acflag), UINT16, "x"},
+	{"acflg", "", "acflag"},
+	{"args", "", "command"},
+	{"blocked", "", "sigmask"},
+	{"caught", "", "sigcatch"},
+	{"comm", "", "ucomm"},
+	{"command", "COMMAND", NULL, COMM|LJUST|USER, command, 16},
+	{"cpu", "CPU", NULL, 0, pvar, 3, 0, POFF(p_estcpu), UINT32, "d"},
+	{"cpuid", "CPUID", NULL, 0, pvar, 8, 0, POFF(p_cpuid), UINT64, "lld"},
+	{"cputime", "", "time"},
+	{"dsiz", "DSIZ", NULL, 0, dsize, 4},
+	{"emul", "EMUL", NULL, LJUST, emulname, EMULNAMELEN},
+	{"etime", "", "start"},
+	{"f", "F", NULL, 0, pvar, 7, 0, POFF(p_flag), INT32, "x"},
+	{"flags", "", "f"},
+	GID("gid", "GID", pvar, POFF(p_gid)),
+	{"group", "GROUP", NULL, LJUST, gname, USERLEN},
+	{"ignored", "", "sigignore"},
+	{"inblk", "INBLK", NULL, USER, pvar, 4, 0, POFF(p_uru_inblock), UINT64, "lld"},
+	{"inblock", "", "inblk"},
+	{"jobc", "JOBC", NULL, 0, pvar, 4, 0, POFF(p_jobc), INT16, "d"},
+	{"ktrace", "KTRACE", NULL, 0, pvar, 8, 0, POFF(p_traceflag), INT32, "x"},
+	/* XXX */
+	{"ktracep", "KTRACEP", NULL, 0, pvar, 8, 0, POFF(p_tracep), UINT64, "llx"},
+	{"lim", "LIM", NULL, 0, maxrss, 5},
+	{"login", "LOGIN", NULL, LJUST, logname, MAXLOGNAME},
+	{"logname", "", "login"},
+	{"lstart", "STARTED", NULL, LJUST|USER, lstarted, 28},
+	{"majflt", "MAJFLT", NULL, USER, pvar, 4, 0, POFF(p_uru_majflt), UINT64, "lld"},
+	{"minflt", "MINFLT", NULL, USER, pvar, 4, 0, POFF(p_uru_minflt), UINT64, "lld"},
+	{"msgrcv", "MSGRCV", NULL, USER, pvar, 4, 0, POFF(p_uru_msgrcv), UINT64, "lld"},
+	{"msgsnd", "MSGSND", NULL, USER, pvar, 4, 0, POFF(p_uru_msgsnd), UINT64, "lld"},
+	{"ni", "", "nice"},
+	{"nice", "NI", NULL, 0, pnice, 3},
+	{"nivcsw", "NIVCSW", NULL, USER, pvar, 5, 0, POFF(p_uru_nivcsw), UINT64, "lld"},
+	{"nsignals", "", "nsigs"},
+	{"nsigs", "NSIGS", NULL, USER, pvar, 4, 0, POFF(p_uru_nsignals), UINT64, "lld"},
+	{"nswap", "NSWAP", NULL, USER, pvar, 4, 0, POFF(p_uru_nswap), UINT64, "lld"},
+	{"nvcsw", "NVCSW", NULL, USER, pvar, 5, 0, POFF(p_uru_nvcsw), UINT64, "lld"},
+	/* XXX */
+	{"nwchan", "WCHAN", NULL, 0, pvar, 7, 0, POFF(p_wchan), UINT64, "llx"},
+	{"oublk", "OUBLK", NULL, USER, pvar, 4, 0, POFF(p_uru_oublock), UINT64, "lld"},
+	{"oublock", "", "oublk"},
+	/* XXX */
+	{"p_ru", "P_RU", NULL, 0, pvar, 6, 0, POFF(p_ru), UINT64, "llx"},
+	/* XXX */
+	{"paddr", "PADDR", NULL, 0, pvar, 6, 0, POFF(p_paddr), UINT64, "llx"},
+	{"pagein", "PAGEIN", NULL, USER, pagein, 6},
+	{"pcpu", "", "%cpu"},
+	{"pending", "", "sig"},
+	PID("pgid", "PGID", pvar, POFF(p__pgid)),
+	PID("pid", "PID", pvar, POFF(p_pid)),
+	{"pmem", "", "%mem"},
+	PID("ppid", "PPID", pvar, POFF(p_ppid)),
+	{"pri", "PRI", NULL, 0, pri, 3},
+	{"re", "RE", NULL, INF127, pvar, 3, 0, POFF(p_swtime), UINT32, "u"},
+	GID("rgid", "RGID", pvar, POFF(p_rgid)),
+	/* XXX */
+	{"rgroup", "RGROUP", NULL, LJUST, rgname, USERLEN},
+	{"rlink", "RLINK", NULL, 0, pvar, 8, 0, POFF(p_back), UINT64, "llx"},
+	{"rss", "RSS", NULL, 0, p_rssize, 5},
+	{"rssize", "", "rsz"},
+	{"rsz", "RSZ", NULL, 0, rssize, 4},
+	UID("ruid", "RUID", pvar, POFF(p_ruid)),
+	{"ruser", "RUSER", NULL, LJUST, runame, USERLEN},
+	{"sess", "SESS", NULL, 0, pvar, PTRWIDTH, 0, POFF(p_sess), UINT64, "llx"},
+	{"sig", "PENDING", NULL, 0, pvar, 8, 0, POFF(p_siglist), INT32, "x"},
+	{"sigcatch", "CAUGHT", NULL, 0, pvar, 8, 0, POFF(p_sigcatch), UINT32, "x"},
+	{"sigignore", "IGNORED",
+		NULL, 0, pvar, 8, 0, POFF(p_sigignore), UINT32, "x"},
+	{"sigmask", "BLOCKED", NULL, 0, pvar, 8, 0, POFF(p_sigmask), UINT32, "x"},
+	{"sl", "SL", NULL, INF127, pvar, 3, 0, POFF(p_slptime), UINT32, "u"},
+	{"ssiz", "SSIZ", NULL, 0, ssize, 4},
+	{"start", "STARTED", NULL, LJUST|USER, started, 8},
+	{"stat", "", "state"},
+	{"state", "STAT", NULL, LJUST|NLIST, state, 5},
+	GID("svgid", "SVGID", pvar, POFF(p_svgid)),
+	UID("svuid", "SVUID", pvar, POFF(p_svuid)),
+	{"tdev", "TDEV", NULL, 0, tdev, 4},
+	{"time", "TIME", NULL, USER, cputime, 9},
+	PID("tpgid", "TPGID", pvar, POFF(p_tpgid)),
+	{"tsess", "TSESS", NULL, 0, pvar, PTRWIDTH, 0, POFF(p_tsess), UINT64, "llx"},
+	{"tsiz", "TSIZ", NULL, 0, tsize, 4},
+	{"tt", "TT", NULL, LJUST, tname, 3},
+	{"tty", "TTY", NULL, LJUST, longtname, 8},
+	{"ucomm", "UCOMM", NULL, LJUST, ucomm, MAXCOMLEN},
+	UID("uid", "UID", pvar, POFF(p_uid)),
+	{"upr", "UPR", NULL, 0, pvar, 3, 0, POFF(p_usrpri), UINT8, "d"},
+	{"user", "USER", NULL, LJUST, euname, USERLEN},
+	{"usrpri", "", "upr"},
+	{"vsize", "", "vsz"},
+	{"vsz", "VSZ", NULL, 0, vsize, 5},
+	{"wchan", "WCHAN", NULL, LJUST, wchan, 7},
+	{"xstat", "XSTAT", NULL, 0, pvar, 4, 0, POFF(p_xstat), UINT16, "x"},
+	{""},
+};
+
+void
+showkey(void)
+{
+	VAR *v;
+	int i;
+	char *p, *sep;
+
+	i = 0;
+	sep = "";
+	for (v = var; *(p = v->name); ++v) {
+		int len = strlen(p);
+		if (termwidth && (i += len + 1) > termwidth) {
+			i = len;
+			sep = "\n";
+		}
+		(void) printf("%s%s", sep, p);
+		sep = " ";
+	}
+	(void) printf("\n");
+}
+
+void
+parsefmt(char *p)
+{
+	static struct varent *vtail;
+
+#define	FMTSEP	" \t,\n"
+	while (p && *p) {
+		char *cp;
+		VAR *v;
+		struct varent *vent;
+
+		while ((cp = strsep(&p, FMTSEP)) != NULL && *cp == '\0')
+			/* void */;
+		if (!cp)
+			break;
+		if (!(v = findvar(cp)) || v->parsed == 1)
+			continue;
+		v->parsed = 1;
+		if ((vent = malloc(sizeof(struct varent))) == NULL)
+			err(1, NULL);
+		vent->var = v;
+		vent->next = NULL;
+		if (vhead == NULL)
+			vhead = vtail = vent;
+		else {
+			vtail->next = vent;
+			vtail = vent;
+		}
+	}
+	if (!vhead)
+		errx(1, "no valid keywords");
+}
+
+static VAR *
+findvar(char *p)
+{
+	VAR *v, key;
+	char *hp;
+	int vcmp(const void *, const void *);
+
+	key.name = p;
+
+	hp = strchr(p, '=');
+	if (hp)
+		*hp++ = '\0';
+
+	key.name = p;
+	v = bsearch(&key, var, sizeof(var)/sizeof(VAR) - 1, sizeof(VAR), vcmp);
+
+	if (v && v->alias) {
+		if (hp) {
+			warnx("%s: illegal keyword specification", p);
+			eval = 1;
+		}
+		parsefmt(v->alias);
+		return (NULL);
+	}
+	if (!v) {
+		warnx("%s: keyword not found", p);
+		eval = 1;
+		return (NULL);
+	}
+	if (hp)
+		v->header = hp;
+	return (v);
+}
+
+static int
+vcmp(const void *a, const void *b)
+{
+	return (strcmp(((VAR *)a)->name, ((VAR *)b)->name));
+}
